## python-defaults 2.7.15~rc1-1

=== tests/t3/Makefile ===
#!/usr/bin/make -f

include ../common.mk
DPY=$(DEBPYTHON_DEFAULT)

check:
	grep -q "pycompile -p python-foo /usr/lib/python-foo -V $(DPY)"\
		debian/python-foo/DEBIAN/postinst
	test -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/bar.so
	test ! -f debian/python-foo/usr/share/pyshared/foo/bar.so
	test -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/spam.so
	test ! -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/spam.so.0.1
	test -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/baz.so
	test ! -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/baz.so.0.1
	test ! -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/baz.so.0.1.2
	test -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/quux.so
	test ! -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/quux.so.0
	test ! -L debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/quux.so.0
	test ! -f debian/python-foo/usr/lib/python${DPY}/dist-packages/foo/quux.so.0.0.0

clean: clean-common
	rm -rf lib/Foo.egg-info build

=== tests/t6/Makefile ===
#!/usr/bin/make -f

include ../common.mk
clean: clean-common

check:
	# python2.4 hardcoded via `dh_python2 -V 2.4`
	grep -q Depends:.*python2.4 debian/foo/DEBIAN/control
	grep -q '\-V 2.4 /usr/share/baz24' debian/foo/usr/share/python/runtime.d/foo.rtupdate
	grep -q '/usr/share/baz24 \-V 2.4' debian/foo/DEBIAN/postinst
	# python2.5 due to X-Python-Version: 2.5
	grep -q Depends:.*python2.5 debian/foo/DEBIAN/control
	grep -q '\-V 2.5 /usr/share/bar25' debian/foo/usr/share/python/runtime.d/foo.rtupdate
	grep -q '/usr/share/bar25 \-V 2.5' debian/foo/DEBIAN/postinst
	# python2.6 hardcoded via shebang
ifneq (,$(findstring 2.6,$(DEBPYTHON_SUPPORTED)))
	grep -q Depends:.*python2.6 debian/foo/DEBIAN/control
	grep -q '\-V 2.6 /usr/share/foo' debian/foo/usr/share/python/runtime.d/foo.rtupdate
	grep -q '/usr/share/foo \-V 2.6' debian/foo/DEBIAN/postinst
endif

=== debian/changelog ===
python-defaults (2.7.15~rc1-1) unstable; urgency=medium

  * Bump version to 2.7.15~rc1.
  * debian/control.in (Michael Vogt):
    - add Cnf-Visible-Pkgname hint to ensure command-not-found recommends
      installing "python" instead of "python-minimal" when it is missing.

 -- Matthias Klose <doko@debian.org>  Mon, 16 Apr 2018 16:31:18 +0200

python-defaults (2.7.14-4) unstable; urgency=medium

  * Stop building the python-examples and idle2 packages.
  * python: Stop shipping the 2to3 symlink (now in the 2to3 package).

 -- Matthias Klose <doko@debian.org>  Wed, 13 Dec 2017 23:39:49 +0100

python-defaults (2.7.14-3) unstable; urgency=medium

  * Stop using priority extra for the -dbg packages.
  * pycompile, pyclean, pyversions: Use python2 as the shebang to guard
    against people fiddling around with the python symlink or having a
    python3 installed as python in /usr/local. Closes: #864599. LP: #1715062.
  * Rename the idle package to idle2. idle is now built for python3.
  * Fix quoting in the prerm-clean autoscript. Closes: #815134.
  * README.Debian: Reference 2.7 and point to the python3 package for the
    Debian Python Policy.
  * Mark python-examples as M-A: foreign.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Dec 2017 10:56:48 +0100

=== debian/control ===
Source: python-defaults
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Uploaders: Scott Kitterman <scott@kitterman.com>, Piotr Ożarowski <piotr@debian.org>, Barry Warsaw <barry@debian.org>
Build-Depends: debhelper (>= 9~), dpkg-dev (>= 1.17.11), python2.7:any (>= 2.7.11-11),
  lsb-release,
  python-all:any,
  python2.7:any (>= 2.7.15~rc1-1~),
  docbook-xml,
  docbook-xsl,
  w3m,
  xsltproc,
Standards-Version: 4.1.4
Homepage: http://www.python.org/
Vcs-Bzr: http://alioth.debian.org/anonscm/bzr/pkg-python/python-defaults-debian
Vcs-Browser: http://alioth.debian.org/scm/loggerhead/pkg-python/python-defaults-debian/files

Package: python
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: python-minimal (= ${binary:Version})
Depends: ${misc:Depends}, python2.7 (>= 2.7.15~rc1-1~), libpython-stdlib (= ${binary:Version})
Suggests: python-doc (= ${binary:Version}), python-tk (>= 2.7.15~rc1-1~)
Conflicts: python-central (<< 0.5.5)
Breaks: update-manager-core (<< 0.200.5-2)
Replaces: python-dev (<< 2.6.5-2)
Provides: python-email, python-ctypes, python-wsgiref, python-importlib, python-profiler
Description: interactive high-level object-oriented language (default version)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on Debian's default
 Python version (currently v2.7).
XB-Cnf-Extra-Commands: python
XB-Cnf-Priority-Bonus: 3

Package: python-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: ${misc:Depends}, python2.7-minimal (>= 2.7.15~rc1-1~), dpkg (>= 1.13.20)
Recommends: python
Conflicts: python-central (<< 0.5.5)
Breaks: python (<= 2.7.3-1~), python-dev (<< 2.6), python-dbg (<< 2.6), python-all (<< 2.6), python-all-dev (<< 2.6), python-all-dbg (<< 2.6), python-examples (<< 2.6), idle (<< 2.6), python2.5-minimal (<< 2.5.5-7), python2.6-minimal (<< 2.6.5~rc2-2), python3.1-minimal (<< 3.1.2~rc1-2), python-support (<< 1.0.10ubuntu2)
Replaces: python (<= 2.7.3-1~)
Description: minimal subset of the Python language (default version)
 This package contains the interpreter and some essential modules.  It's used
 in the boot process for some basic tasks.
 See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
 contained in this package.
Cnf-Visible-Pkgname: python

Package: python-dev
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), libpython-dev (= ${binary:Version}), python2.7-dev (>= 2.7.15~rc1-1~)
Description: header files and a static library for Python (default)
 Header files, a static library and development tools for building
 Python modules, extending the Python interpreter or embedding Python
 in applications.
 .
 This package is a dependency package, which depends on Debian's default
 Python version (currently v2.7).

Package: libpython-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpython2.7-dev (>= 2.7.15~rc1-1~), ${misc:Depends}
Description: header files and a static library for Python (default)
 Header files, a static library and development tools for building
 Python modules, extending the Python interpreter or embedding Python
 in applications.
 .
 This package is a dependency package, which depends on Debian's default
 Python version (currently v2.7).

Package: libpython-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Depends: libpython2.7-stdlib (>= 2.7.15~rc1-1~), ${misc:Depends}
Description: interactive high-level object-oriented language (default python version)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on Debian's default
 Python version (currently v2.7).

Package: python-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, python2.7-doc (>= 2.7.15~rc1-1~)
Suggests: python-examples, python (= ${binary:Version})
Breaks: python (<< 2.3.5)
Replaces: python (<< 2.3.5)
Description: documentation for the high-level object-oriented language Python
 This is the official set of documentation for the interactive high-level
 object-oriented language Python (v2.7). All documents are provided
 in HTML format, some in info format. The package consists of nine documents:
 .
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules
 .
 This package is a dependency package, which depends on Debian's default
 Python version (currently v2.7).

Package: python-dbg
Architecture: any
Multi-Arch: allowed
Section: debug
Depends: ${misc:Depends}, python (= ${binary:Version}), libpython-dbg (= ${binary:Version}), python2.7-dbg (>= 2.7.15~rc1-1~)
Description: debug build of the Python Interpreter (version 2.7)
 Python interpreter configured with --pydebug. Dynamically loaded modules are
 searched in /usr/lib/python2.7/lib-dynload/debug first.

Package: libpython-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: libpython2.7-dbg (>= 2.7.15~rc1-1~), ${misc:Depends}
Description: debug build of the Python Interpreter (version 2.7)
 Python interpreter configured with --pydebug. Dynamically loaded modules
 are searched in /usr/lib/python2.7/lib-dynload/debug first.

Package: python-all
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), python2.7 (>= 2.7.2-3)
Description: package depending on all supported Python runtime versions
 The package currently depends on python2.7, in the future,
 dependencies on jython (Python for a JVM) and ironpython (Python for Mono)
 may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python runtimes.

Package: python-all-dev
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), python-all (= ${binary:Version}), libpython-all-dev (= ${binary:Version}), python-dev (= ${binary:Version}), python2.7-dev (>= 2.7-7)
Description: package depending on all supported Python development packages
 The package currently depends on python2.7-dev, in the
 future, dependencies on jython (Python for a JVM) and ironpython (Python
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python development
 packages.

Package: python-all-dbg
Architecture: any
Multi-Arch: allowed
Section: debug
Depends: ${misc:Depends}, python (= ${binary:Version}), python-all (= ${binary:Version}), libpython-all-dbg (= ${binary:Version}), python-dbg (= ${binary:Version}), python2.7-dbg (>= 2.7-7)
Description: package depending on all supported Python debugging packages
 The package currently depends on python2.7-dbg, in the
 future, dependencies on jython (Python for a JVM) and ironpython (Python
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python debug packages.

Package: libpython-all-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpython-dev (= ${binary:Version}), ${misc:Depends},
 libpython2.7-dev
Description: package depending on all supported Python development packages
 The package currently depends on libpython2.7-dev, in the
 future, dependencies on jython (Python for a JVM) and ironpython (Python
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python development
 packages.

Package: libpython-all-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: libpython-dbg (= ${binary:Version}), ${misc:Depends},
 libpython2.7-dbg
Description: package depending on all supported Python debugging packages
 The package currently depends on libpython2.7-dbg, in the
 future, dependencies on jython (Python for a JVM) and ironpython (Python
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python debug packages.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

changelog_values := $(shell dpkg-parsechangelog \
			| awk '/^(Version|Source):/ {print $$2}')
PKGSOURCE  := $(word 1, $(changelog_values))
PKGVERSION := $(word 2, $(changelog_values))

distribution := $(shell dpkg-vendor --query Vendor)
distrelease  := $(shell lsb_release -cs)

export VER=2.7
export NVER=2.8
export PVER=python2.7

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)
# first version with Multi-Arch: allowed
PREVVER := 2.7.15~rc1-1~

# not yet allowed
ma_allowed	= yes

ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_i586 = dpkg-dev (>= 1.17.11), python2.7:any (>= 2.7.11-11)
endif


PWD		:= $(shell pwd)

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

rst2html	= rst2html

with_doc	= yes
ifneq ($(with_doc),yes)
  NOPKGS	= -Npython-doc
endif

build: stamp-build
build-arch: stamp-build
build-indep: stamp-build
stamp-build:
	touch stamp-build

stamp-doc-policy:
	xsltproc --nonet --novalid debian/html.xsl debian/python-policy.dbk \
	    | w3m -o display_charset=UTF-8 -cols 70 -dump -no-graph -T text/html > python-policy.txt
	mv -f python-policy.txt debian/
	rm -rf debian/python-policy.html
	mkdir python-policy.html
	( cd python-policy.html; xsltproc --nonet --novalid ../debian/chunk.xsl ../debian/python-policy.dbk )
	mv -f python-policy.html debian/
	make -C pydist
	touch stamp-doc-policy

stamp-doc: stamp-doc-policy
	touch stamp-doc

control-file:
	sed -e "s/@PVER@/$(PVER)/g" \
	    -e "s/@NVER@/$(NVER)/g" \
	    -e "s/@VER@/$(VER)/g" \
	    -e "s/@PREVVER@/$(PREVVER)/g" \
	    -e "s/@bd_i586@/$(bd_i586)/g" \
		<debian/control.in \
	    $(if $(ma_allowed),,| grep -v '^Multi-Arch: allowed$$') \
		>debian/control.tmp
ifeq ($(distribution),Ubuntu)
  ifneq (,$(findstring ubuntu, $(PKGVERSION)))
	m='Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>'; \
	sed -i "/^Maintainer:/s/\(.*\)/Maintainer: $$m\nXSBC-Original-\1/" \
	  debian/control.tmp
  endif
endif
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control

faqs = index general programming library extending windows gui installed
get-faq:
	# Note: This rule is broken due to web site reorg at python.org
	rm -rf faq
	mkdir faq
	cd faq && \
	  wget -nv $(foreach p,$(faqs),http://python.org/doc/faq/$(p).ht)
	sed 's,\<\([a-zA-Z0-9]*\.html\)\>,faq/\1,' faq/index.ht \
		| awk '/^Translations$$/ {exit} {print}' > faq/FAQ.ht
	( \
	  echo ''; \
	  echo 'This is a local copy of the online FAQ located at'; \
	  echo 'http://python.org/doc/faq.'; \
	  echo "The copy was fetched and generated in `date '+%B %Y'`."; \
	) >> faq/FAQ.ht
	rm -f faq/index.ht

make-faq:
	set -e; \
	cd faq && \
	for p in *.ht; do \
	  p=`basename $$p .ht`; \
	  echo $(rst2html) $$p.ht $$p.html; \
	  awk 'NR > 2' $$p.ht > $$p.ht2; \
	  $(rst2html) $$p.ht2 $$p.html; \
	  rm -f $$p.ht2; \
	done

MANPAGES ?= dh_python2.1 pycompile.1 pyclean.1

%.1: %.rst
	rst2man $< > $@

# Manually run this rule if there is a need to update the dh_python2 man pages
make-man: $(MANPAGES)
	cd pydist && \
	rst2html README.PyDist > README.PyDist.html

clean: control-file
	dh_testdir
	dh_testroot
	rm -f stamp-*
	rm -f patch-stamp*

	rm -f debian/python-policy.txt
	rm -rf debian/python-policy.html

	set -e;\
	for f in debian/*.in; do \
	    f2=`echo $$f | sed "s,PVER,$(PVER),g;s/VER/$(VER)/g;s,\.in$$,,"`; \
	    if [ $$f2 != debian/control ]; then \
	        rm -f $$f2; \
	    fi; \
	done
	rm -f debian/*.py[co]
	make clean
	dh_clean

stamp-control:
	: # We have to prepare the various control files

	set -e;\
	for f in debian/*.in; do \
	    f2=`echo $$f | sed "s,PVER,$(PVER),g;s/VER/$(VER)/g;s,\.in$$,,"`; \
	    if [ $$f2 != debian/control ]; then \
		sed -e "s/@PVER@/$(PVER)/g;s/@VER@/$(VER)/g" \
		    -e "s/@PRIORITY@/$(PRIORITY)/g" \
		    -e "s,@SCRIPTDIR@,/$(scriptdir),g" \
		  <$$f >$$f2; \
	    fi; \
	done

install: build stamp-dh_python stamp-install
stamp-install: stamp-build control-file stamp-control
	dh_testdir
	dh_testroot
	dh_installdirs usr/share/doc/python/faq
	dh_install

	set -e; \
	cd faq && \
	for p in *.ht; do \
	  p=`basename $$p .ht`; \
	  cp $$p.html ../debian/python/usr/share/doc/python/faq/; \
	done
	mv debian/python/usr/share/doc/python/faq/FAQ.html \
		debian/python/usr/share/doc/python/

	touch stamp-install

stamp-dh_python:
	dh_testdir
	dh_testroot
	dh_installdirs
	-make check_versions
	DESTDIR=debian/python PREFIX=/usr make install-dev
	DESTDIR=debian/python-minimal PREFIX=/usr make install-runtime
	# disabled by default, run manually if you want to update it
	# (requires apt-file and network connection)
	#make -C pydist dist_fallback
	touch $@

# Build architecture-independent files here.
binary-indep: build install stamp-doc
	dh_testdir -i
	dh_testroot -i
	dh_installman -i

ifeq ($(with_doc),yes)
	dh_installdocs -ppython-doc debian/README.Debian
	dh_installchangelogs -ppython-doc
	mkdir -p debian/python-doc/usr/share/doc/python
	ln -sf ../python$(VER)-doc/html \
		debian/python-doc/usr/share/doc/python/html
	mkdir -p debian/python-doc/usr/share/doc/python-doc
	ln -sf ../python$(VER)-doc/html \
		debian/python-doc/usr/share/doc/python-doc/html
endif

#	dh_installdebconf -i $(NOPKGS)
	dh_lintian -i
	dh_installdocs -i $(NOPKGS) --all debian/README.Debian
	dh_installchangelogs -i $(NOPKGS)

	dh_compress -i $(NOPKGS)
	dh_fixperms -i $(NOPKGS)
	dh_installdeb -i $(NOPKGS)
	dh_gencontrol -i $(NOPKGS)
	dh_md5sums -i $(NOPKGS)
	dh_builddeb -i $(NOPKGS)

# Build architecture-dependent files here.
binary-arch: build install stamp-doc
	dh_testdir -a
	dh_testroot -a
	dh_installman -a

	: # provide the python and python.1 defaults
	mkdir -p debian/python-minimal/usr/bin
	ln -sf python$(VER) debian/python-minimal/usr/bin/python
	ln -sf python$(VER) debian/python-minimal/usr/bin/python2
	mkdir -p debian/python-minimal/usr/share/man/man1
	ln -sf python$(VER).1.gz \
		debian/python-minimal/usr/share/man/man1/python.1.gz
	ln -sf python$(VER).1.gz \
		debian/python-minimal/usr/share/man/man1/python2.1.gz

	: # 
	mkdir -p debian/python-minimal/usr/share/python
	cp -p debian/debian_defaults \
		debian/python-minimal/usr/share/python/

	install -m 755 debian/pyversions.py \
		debian/python-minimal/usr/share/python/
	install -m 644 debian/pyversions.1 \
		debian/python-minimal/usr/share/man/man1/
	dh_link -ppython-minimal /usr/share/python/pyversions.py /usr/bin/pyversions

#	install -m 755 debian/pycompile \
#		debian/python-minimal/usr/bin/
#	install -m 755 debian/pyclean \
#		debian/python-minimal/usr/bin/

#	mkdir debian/python-minimal/usr/share/python-central
#	cp -p debian/python.pycentral debian/python-minimal/usr/share/python-central/

	mkdir -p debian/python/usr/bin
	ln -sf pydoc$(VER) debian/python/usr/bin/pydoc
	ln -sf pygettext$(VER) debian/python/usr/bin/pygettext
	ln -sf pdb$(VER) debian/python/usr/bin/pdb

	mkdir -p debian/python/usr/share/python
	install -m 644 debian/python.mk \
		debian/python/usr/share/python/

	mkdir -p debian/python/usr/share/man/man1
	ln -sf pydoc$(VER).1.gz \
		debian/python/usr/share/man/man1/pydoc.1.gz
	ln -sf pygettext$(VER).1.gz \
		debian/python/usr/share/man/man1/pygettext.1.gz
	ln -sf pdb$(VER).1.gz \
		debian/python/usr/share/man/man1/pdb.1.gz

	mkdir -p debian/python/usr/share/doc/python
	cp -a debian/python-policy.{html,dbk,txt} \
		debian/python/usr/share/doc/python/

=== tests/t6/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=python_distutils

override_dh_pysupport:
	DH_VERBOSE=1 ../../dh_python2
	DH_VERBOSE=1 ../../dh_python2 /usr/share/bar25
	DH_VERBOSE=1 ../../dh_python2 /usr/share/baz24 -V 2.4

clean:
	dh_clean

## python-defaults 2.7.15-3

=== debian/changelog ===
python-defaults (2.7.15-3) unstable; urgency=medium

  * Fix pyversions -d invocation. Closes: #900983.

 -- Matthias Klose <doko@debian.org>  Thu, 07 Jun 2018 18:57:11 +0200

python-defaults (2.7.15-2) unstable; urgency=medium

  * Don't install the pyclean and pycompile manpages in python-minimal.
  * Don't install dh_python2 manpage in python.
  * Remove unused xsl files, remove unused code in the rules file.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Jun 2018 23:25:58 +0200

python-defaults (2.7.15-1) unstable; urgency=medium

  * Bump version to 2.7.15.
  * Split out a set of python2 packages, and let the python packages depend on
    it. No changes for the "-all" packages.
  * Update Vcs attributes.
  * Remove Barry Warsaw as uploader.
  * Remove the FAQ for Python2.
  * Remove the Debian Python policy, now found in the python3 package.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Jun 2018 18:35:07 +0200

=== debian/control ===
Source: python-defaults
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Uploaders: Scott Kitterman <scott@kitterman.com>, Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper (>= 9~), dpkg-dev (>= 1.17.11), python2.7:any (>= 2.7.15-1),
  lsb-release,
  python-all:any,
  python2.7:any (>= 2.7.15-1~),
Standards-Version: 4.1.4
Homepage: https://www.python.org/
Vcs-Git: https://salsa.debian.org/cpython-team/python-defaults.git
Vcs-Browser: https://salsa.debian.org/cpython-team/python-defaults

Package: python
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: python-minimal (= ${binary:Version})
Depends: ${misc:Depends}, python2.7 (>= 2.7.15-1~), libpython-stdlib (= ${binary:Version}), python2 (= ${binary:Version})
Suggests: python-doc (= ${binary:Version}), python-tk (>= 2.7.15-1~)
Conflicts: python-central (<< 0.5.5)
Breaks: update-manager-core (<< 0.200.5-2)
Replaces: python-dev (<< 2.6.5-2)
Provides: python-email, python-ctypes, python-wsgiref, python-importlib, python-profiler
Description: interactive high-level object-oriented language (Python2 version)
 Python2, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).
XB-Cnf-Extra-Commands: python
XB-Cnf-Priority-Bonus: 3

Package: python-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: ${misc:Depends}, python2.7-minimal (>= 2.7.15-1~), dpkg (>= 1.13.20), python2-minimal (= ${binary:Version})
Recommends: python
Conflicts: python-central (<< 0.5.5)
Breaks: python (<= 2.7.3-1~), python-dev (<< 2.6), python-dbg (<< 2.6), python-all (<< 2.6), python-all-dev (<< 2.6), python-all-dbg (<< 2.6), python-examples (<< 2.6), idle (<< 2.6), python2.5-minimal (<< 2.5.5-7), python2.6-minimal (<< 2.6.5~rc2-2), python3.1-minimal (<< 3.1.2~rc1-2), python-support (<< 1.0.10ubuntu2)
Replaces: python (<= 2.7.3-1~)
Description: minimal subset of the Python2 language
 This package contains the interpreter and some essential modules.  It's used
 in the boot process for some basic tasks.
 See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
 contained in this package.
Cnf-Visible-Pkgname: python

Package: python-dev
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), libpython-dev (= ${binary:Version}), python2.7-dev (>= 2.7.15-1~), python2-dev (= ${binary:Version})
Description: header files and a static library for Python2
 Header files, a static library and development tools for building
 Python2 modules, extending the Python2 interpreter or embedding Python2
 in applications.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: libpython-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpython2.7-dev (>= 2.7.15-1~), ${misc:Depends}, libpython2-dev (= ${binary:Version})
Description: header files and a static library for Python2
 Header files, a static library and development tools for building
 Python2 modules, extending the Python2 interpreter or embedding Python2
 in applications.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: libpython-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Depends: libpython2.7-stdlib (>= 2.7.15-1~), ${misc:Depends}, libpython2-stdlib (= ${binary:Version})
Description: interactive high-level object-oriented language (Python2)
 Python2, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: python-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, python2.7-doc (>= 2.7.15-1~), python2-doc (= ${binary:Version})
Suggests: python-examples, python (= ${binary:Version})
Breaks: python (<< 2.3.5)
Replaces: python (<< 2.3.5)
Description: documentation for the high-level object-oriented language Python2
 This is the official set of documentation for the interactive high-level
 object-oriented language Python2 (v2.7). All documents are provided
 in HTML format, some in info format. The package consists of nine documents:
 .
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: python-dbg
Architecture: any
Multi-Arch: allowed
Section: debug
Depends: ${misc:Depends}, python (= ${binary:Version}), libpython-dbg (= ${binary:Version}), python2.7-dbg (>= 2.7.15-1~), python2-dbg (= ${binary:Version})
Description: debug build of the Python Interpreter2 (version 2.7)
 Python2 interpreter configured with --pydebug. Dynamically loaded modules are
 searched in /usr/lib/python2.7/lib-dynload/debug first.

Package: libpython-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: libpython2.7-dbg (>= 2.7.15-1~), ${misc:Depends}, libpython2-dbg (= ${binary:Version})
Description: debug build of the Python2 Interpreter (version 2.7)
 Python2 interpreter configured with --pydebug. Dynamically loaded modules
 are searched in /usr/lib/python2.7/lib-dynload/debug first.

Package: python-all
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), python2.7 (>= 2.7.2-3)
Description: package depending on all supported Python2 runtime versions
 The package currently depends on python2.7, in the future,
 dependencies on jython (Python2 for a JVM) and ironpython (Python2 for Mono)
 may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python2 runtimes.

Package: python-all-dev
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python (= ${binary:Version}), python-all (= ${binary:Version}), libpython-all-dev (= ${binary:Version}), python-dev (= ${binary:Version}), python2.7-dev (>= 2.7-7)
Description: package depending on all supported Python2 development packages
 The package currently depends on python2.7-dev, in the
 future, dependencies on jython (Python2 for a JVM) and ironpython (Python2
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python2 development
 packages.

Package: python-all-dbg
Architecture: any
Multi-Arch: allowed
Section: debug
Depends: ${misc:Depends}, python (= ${binary:Version}), python-all (= ${binary:Version}), libpython-all-dbg (= ${binary:Version}), python-dbg (= ${binary:Version}), python2.7-dbg (>= 2.7-7)
Description: package depending on all supported Python2 debugging packages
 The package currently depends on python2.7-dbg, in the
 future, dependencies on jython (Python for a JVM) and ironpython (Python2
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python2 debug packages.

Package: libpython-all-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpython-dev (= ${binary:Version}), ${misc:Depends},
 libpython2.7-dev
Description: package depending on all supported Python2 development packages
 The package currently depends on libpython2.7-dev, in the
 future, dependencies on jython (Python2 for a JVM) and ironpython (Python2
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python2 development
 packages.

Package: libpython-all-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: libpython-dbg (= ${binary:Version}), ${misc:Depends},
 libpython2.7-dbg
Description: package depending on all supported Python2 debugging packages
 The package currently depends on libpython2.7-dbg, in the
 future, dependencies on jython (Python2 for a JVM) and ironpython (Python2
 for Mono) may be added.
 .
 This package is a dependency package used as a build dependency for other
 packages to avoid hardcoded dependencies on specific Python2 debug packages.

Package: python2
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: python2-minimal (= ${binary:Version})
Depends: ${misc:Depends}, python2.7 (>= 2.7.15-1~), libpython2-stdlib (= ${binary:Version})
Suggests: python2-doc (= ${binary:Version}), python-tk (>= 2.7.15-1~)
Conflicts: python-central (<< 0.5.5)
Breaks: update-manager-core (<< 0.200.5-2), python (<< 2.7.15-2)
Replaces: python-dev (<< 2.6.5-2), python (<< 2.7.15-2)
Provides: python-email, python-ctypes, python-wsgiref, python-importlib, python-profiler
Description: interactive high-level object-oriented language (Python2 version)
 Python2, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).
XB-Cnf-Extra-Commands: python2
XB-Cnf-Priority-Bonus: 3

Package: python2-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: ${misc:Depends}, python2.7-minimal (>= 2.7.15-1~), dpkg (>= 1.13.20)
Recommends: python2
Conflicts: python-central (<< 0.5.5)
Breaks: python (<= 2.7.3-1~), python-dev (<< 2.6), python-dbg (<< 2.6), python-all (<< 2.6), python-all-dev (<< 2.6), python-all-dbg (<< 2.6), python-examples (<< 2.6), idle (<< 2.6), python2.5-minimal (<< 2.5.5-7), python2.6-minimal (<< 2.6.5~rc2-2), python3.1-minimal (<< 3.1.2~rc1-2), python-support (<< 1.0.10ubuntu2), python-minimal (<< 2.7.15-2)
Replaces: python (<= 2.7.3-1~), python-minimal (<< 2.7.15-2)
Description: minimal subset of the Python2 language
 This package contains the interpreter and some essential modules.  It's used
 in the boot process for some basic tasks.
 See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
 contained in this package.
Cnf-Visible-Pkgname: python2

Package: python2-dev
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, python2 (= ${binary:Version}), libpython2-dev (= ${binary:Version}), python2.7-dev (>= 2.7.15-1~)
Breaks: python-dev (<< 2.7.15-2)
Replaces: python-dev (<< 2.7.15-2)
Description: header files and a static library for Python2
 Header files, a static library and development tools for building
 Python2 modules, extending the Python2 interpreter or embedding Python2
 in applications.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: libpython2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpython2.7-dev (>= 2.7.15-1~), ${misc:Depends}
Breaks: libpython-dev (<< 2.7.15-2)
Replaces: libpython-dev (<< 2.7.15-2)
Description: header files and a static library for Python2
 Header files, a static library and development tools for building
 Python2 modules, extending the Python2 interpreter or embedding Python2
 in applications.
 .
 This package is a dependency package, which depends on Debian's Python2
 version (currently v2.7).

Package: libpython2-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Depends: libpython2.7-stdlib (>= 2.7.15-1~), ${misc:Depends}
Breaks: libpython-stdlib (<< 2.7.15-2)
Replaces: libpython-stdlib (<< 2.7.15-2)
Description: interactive high-level object-oriented language (Python2)

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

changelog_values := $(shell dpkg-parsechangelog \
			| awk '/^(Version|Source):/ {print $$2}')
PKGSOURCE  := $(word 1, $(changelog_values))
PKGVERSION := $(word 2, $(changelog_values))

distribution := $(shell dpkg-vendor --query Vendor)
distrelease  := $(shell lsb_release -cs)

export VER=2.7
export NVER=2.8
export PVER=python2.7

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)
# first version with Multi-Arch: allowed
PREVVER := 2.7.15-1~

# not yet allowed
ma_allowed	= yes

ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_i586 = dpkg-dev (>= 1.17.11), python2.7:any (>= 2.7.15-1)
endif


PWD		:= $(shell pwd)

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

rst2html	= rst2html

with_doc	= yes
ifneq ($(with_doc),yes)
  NOPKGS	= -Npython-doc
endif

build: stamp-build
build-arch: stamp-build
build-indep: stamp-build
stamp-build:
	touch stamp-build

control-file:
	sed -e "s/@PVER@/$(PVER)/g" \
	    -e "s/@NVER@/$(NVER)/g" \
	    -e "s/@VER@/$(VER)/g" \
	    -e "s/@PREVVER@/$(PREVVER)/g" \
	    -e "s/@bd_i586@/$(bd_i586)/g" \
		<debian/control.in \
	    $(if $(ma_allowed),,| grep -v '^Multi-Arch: allowed$$') \
		>debian/control.tmp
ifeq ($(distribution),Ubuntu)
  ifneq (,$(findstring ubuntu, $(PKGVERSION)))
	m='Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>'; \
	sed -i "/^Maintainer:/s/\(.*\)/Maintainer: $$m\nXSBC-Original-\1/" \
	  debian/control.tmp
  endif
endif
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control

MANPAGES ?= dh_python2.1 pycompile.1 pyclean.1

%.1: %.rst
	rst2man $< > $@

# Manually run this rule if there is a need to update the dh_python2 man pages
make-man: $(MANPAGES)
	cd pydist && \
	rst2html README.PyDist > README.PyDist.html

clean: control-file
	dh_testdir
	dh_testroot
	rm -f stamp-*
	rm -f patch-stamp*

	set -e;\
	for f in debian/*.in; do \
	    f2=`echo $$f | sed "s,PVER,$(PVER),g;s/VER/$(VER)/g;s,\.in$$,,"`; \
	    if [ $$f2 != debian/control ]; then \
	        rm -f $$f2; \
	    fi; \
	done
	rm -f debian/*.py[co]
	make clean
	dh_clean

stamp-control:
	: # We have to prepare the various control files

	set -e;\
	for f in debian/*.in; do \
	    f2=`echo $$f | sed "s,PVER,$(PVER),g;s/VER/$(VER)/g;s,\.in$$,,"`; \
	    if [ $$f2 != debian/control ]; then \
		sed -e "s/@PVER@/$(PVER)/g;s/@VER@/$(VER)/g" \
		    -e "s/@PRIORITY@/$(PRIORITY)/g" \
		    -e "s,@SCRIPTDIR@,/$(scriptdir),g" \
		  <$$f >$$f2; \
	    fi; \
	done

install: build stamp-dh_python stamp-install
stamp-install: stamp-build control-file stamp-control
	dh_testdir
	dh_testroot
	dh_installdirs -ppython usr/share/doc/python
	dh_install

	touch stamp-install

stamp-dh_python:
	dh_testdir
	dh_testroot
	dh_installdirs
	-make check_versions
	DESTDIR=debian/python2 PREFIX=/usr make install-dev
	DESTDIR=debian/python2-minimal PREFIX=/usr make install-runtime
	# disabled by default, run manually if you want to update it
	# (requires apt-file and network connection)
	#make -C pydist dist_fallback
	touch $@

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installman -i

ifeq ($(with_doc),yes)
	dh_installdocs -ppython-doc -ppython2-doc debian/README.Debian
	dh_installchangelogs -ppython-doc -ppython2-doc
	mkdir -p debian/python-doc/usr/share/doc/python
	ln -sf ../python$(VER)-doc/html \
		debian/python-doc/usr/share/doc/python/html
	mkdir -p debian/python-doc/usr/share/doc/python-doc
	ln -sf ../python$(VER)-doc/html \
		debian/python-doc/usr/share/doc/python-doc/html

	mkdir -p debian/python2-doc/usr/share/doc/python2
	ln -sf ../python$(VER)-doc/html \
		debian/python2-doc/usr/share/doc/python2/html
	mkdir -p debian/python2-doc/usr/share/doc/python2-doc
	ln -sf ../python$(VER)-doc/html \
		debian/python2-doc/usr/share/doc/python2-doc/html
endif

#	dh_installdebconf -i $(NOPKGS)
	dh_lintian -i
	dh_installdocs -i $(NOPKGS) --all debian/README.Debian
	dh_installchangelogs -i $(NOPKGS)

	dh_compress -i $(NOPKGS)
	dh_fixperms -i $(NOPKGS)
	dh_installdeb -i $(NOPKGS)
	dh_gencontrol -i $(NOPKGS)
	dh_md5sums -i $(NOPKGS)
	dh_builddeb -i $(NOPKGS)

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installman -a

	: # provide the python2 and python2.1 defaults
	mkdir -p debian/python2-minimal/usr/bin
	ln -sf python$(VER) debian/python2-minimal/usr/bin/python2
	mkdir -p debian/python2-minimal/usr/share/man/man1
	ln -sf python$(VER).1.gz \
		debian/python2-minimal/usr/share/man/man1/python2.1.gz

	: # provide the python and python.1 defaults
	mkdir -p debian/python-minimal/usr/bin
	ln -sf python2 debian/python-minimal/usr/bin/python
	mkdir -p debian/python-minimal/usr/share/man/man1
	ln -sf python2.1.gz \
		debian/python-minimal/usr/share/man/man1/python.1.gz

	: # 
	mkdir -p debian/python2-minimal/usr/share/python
	cp -p debian/debian_defaults \
		debian/python2-minimal/usr/share/python/

	install -m 755 debian/pyversions.py \
		debian/python2-minimal/usr/share/python/
	install -m 644 debian/pyversions.1 \
		debian/python2-minimal/usr/share/man/man1/
	dh_link -ppython2-minimal /usr/share/python/pyversions.py /usr/bin/pyversions

	mkdir -p debian/python2/usr/bin
	ln -sf pydoc$(VER) debian/python2/usr/bin/pydoc2
	ln -sf pygettext$(VER) debian/python2/usr/bin/pygettext2
	ln -sf pdb$(VER) debian/python2/usr/bin/pdb2

	mkdir -p debian/python/usr/bin
	ln -sf pydoc2 debian/python/usr/bin/pydoc
	ln -sf pygettext2 debian/python/usr/bin/pygettext
	ln -sf pdb2 debian/python/usr/bin/pdb

	mkdir -p debian/python2/usr/share/python
	install -m 644 debian/python.mk \
		debian/python2/usr/share/python/

	mkdir -p debian/python2/usr/share/man/man1
	ln -sf pydoc$(VER).1.gz \
		debian/python2/usr/share/man/man1/pydoc2.1.gz
	ln -sf pygettext$(VER).1.gz \
		debian/python2/usr/share/man/man1/pygettext2.1.gz
	ln -sf pdb$(VER).1.gz \
		debian/python2/usr/share/man/man1/pdb2.1.gz

	mkdir -p debian/python/usr/share/man/man1
	ln -sf pydoc2.1.gz \
		debian/python/usr/share/man/man1/pydoc.1.gz
	ln -sf pygettext2.1.gz \
		debian/python/usr/share/man/man1/pygettext.1.gz
	ln -sf pdb2.1.gz \
		debian/python/usr/share/man/man1/pdb.1.gz

	mkdir -p debian/python2/usr/share/pixmaps
	ln -sf python$(VER).xpm debian/python2/usr/share/pixmaps/python2.xpm

	mkdir -p debian/python/usr/share/pixmaps
	ln -sf python$(VER).xpm debian/python/usr/share/pixmaps/python.xpm

	mkdir -p debian/python2/usr/share/apps/konsole
	cp -p debian/python2.desktop debian/python2/usr/share/apps/konsole/

	mkdir -p debian/python/usr/share/apps/konsole
	cp -p debian/python.desktop debian/python/usr/share/apps/konsole/

	: # provide the python2-config default
	mkdir -p debian/python2-dev/usr/bin
	ln -sf python$(VER)-config debian/python2-dev/usr/bin/python2-config
	mkdir -p debian/python2-dev/usr/share/man/man1
	ln -sf python$(VER)-config.1.gz \
		debian/python2-dev/usr/share/man/man1/python2-config.1.gz

	: # provide the python-config default
	mkdir -p debian/python-dev/usr/bin
	ln -sf python2-config debian/python-dev/usr/bin/python-config
	mkdir -p debian/python-dev/usr/share/man/man1
	ln -sf python2-config.1.gz \
		debian/python-dev/usr/share/man/man1/python-config.1.gz

	: # provide pkgconfig defaults
	mkdir -p debian/python2-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
